// // BEGIN FLOCK GPL
// 
// Copyright Flock Inc. 2005
// http://flock.com
// 
// This file may be used under the terms of of the
// GNU General Public License Version 2 or later (the "GPL"),
// http://www.gnu.org/licenses/gpl.html
// 
// Software distributed under the License is distributed on an "AS IS" basis,
// WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
// for the specific language governing rights and limitations under the
// License.
// 
// END FLOCK GPL
//

// TODO: problem with gB: value is lost after going though XPCOM. Listener is called in a different context. Attach gB to the window? window.gB? 

const FLOCK_RDF = "http://www.flock.com/rdf/";

const nsIFilePicker = Components.interfaces.nsIFilePicker;

function dump_rdf (data_source) {/*{{{*/
  var ser=Components.classes["@mozilla.org/rdf/xml-serializer;1"].createInstance(Components.interfaces.nsIRDFXMLSerializer);
	ser.init(data_source);
  var stream = {
    xml : '',
    close : function(){},
    flush : function(){},
    write : function (buffer,count) { 
      this.xml = this.xml+buffer; 
      return count; 
    },
    writeFrom : function (stream,count){},
    isNonBlocking: false
  };
  ser.QueryInterface(Components.interfaces.nsIRDFXMLSource).Serialize(stream);
  XXX("stream.xml",stream.xml);
}/*}}}*/


var gB = null;
var gNewBlogAccount = null;
var gDetect = null;
var gManualMode = false;

function flock_blogWizardLoad()
{
    flock.blog.settings;
    gNewBlogAccount = new BlogAccount("ignore");
    if(window.arguments && window.arguments.length)
    {
        var arg = window.arguments[0];
        $("blog-wizard-url").value = arg;
        $("blogAccountWizard").advance();
        // window.setAttribute("blogTitle", "test");
    }
    else {
        var qs = new flock_PageQuery(window.location.search);
        if(qs && qs.getValue("title")) {
            $("blog-wizard-url").value = qs.getValue("title");
        }
    }
}

function fillFinalUI2(api)
{
    $("blog-username").value = gNewBlogAccount.username;
    $("blog-password").value = gNewBlogAccount.password;
    $("blog-uri").value =  api.apiLink;
    dump('$("blog-uri").value =  '+api.apiLink+'\n');

    var blogid = api.blogID;
    if(api.blogID.length==0) api.blogID = "1";
    $("blog-blogid").value =  blogid;
}

function fillFinalUI()
{
    if(gB)
    {
        $("blog-api-menu").value = gB.name;
        dump("blog-api-menu set to "+gB.name+"\n");
        fillFinalUI2(gB);
    }
}

function blogWizardStartShow() {
    gManualMode = false;
    $("blogAccountWizard").canAdvance = true;
    $('blog-wizard-url').select();
}

function blogWizardStartAdvance()
{
    //flock_blogInitRDF();
    dump('getting url \n');
    gNewBlogAccount.blogURL = $("blog-wizard-url").value;
    dump('url is ' + gNewBlogAccount.blogURL + ' \n');
    gB = null;
    gDetect = new BlogAPIDetector();
    dump('gDetect is ' + gDetect + ' \n');
    try
    {
        dump('running gDetect \n');
        $('detect-deck').setAttribute('selectedIndex', '0');
        gDetect.detect(new detectListener(), gNewBlogAccount.blogURL);
        $("blogAccountWizard").canAdvance = false;
        $("blogAccountWizard").canRewind = false;
    }
    catch(e)
    {
        dump("Error "+e+" "+e.fileName+" line "+e.lineNumber+"\n");
        var strbundle = document.getElementById("blogStringBundle");
        var msg = strbundle.getString("flock.blog.wizard.invalidurl");
        alert(msg);
        throw new Error("Musn't advance");
    }
    dump('done wiz start advance\n');
}

function blogAccountWizardSelectAPI(aAPIName) {
    dump(aAPIName + "<<<\n");
    if(aAPIName=="unknown") {
        $("blogAccountWizard").canAdvance = false;
    }
    else {
        $("blogAccountWizard").canAdvance = true;
    }
}

function blogWizardDetectAdvance()
{
    // gManualMode = true;
    try
    {
        var strbundle = document.getElementById("blogStringBundle");
        if(gB)
        {
            var label = strbundle.getString("flock.blog.wizard.apidetected.label");
            var msg = strbundle.getString("flock.blog.wizard.apidetected.msg");
            $("blogWizardConfirmSettings").setAttribute("label", label);
            $("blogWizardConfirmSettings").setAttribute("description", msg);
        }
        else
        {
            var label = strbundle.getString("flock.blog.wizard.config.label");
            var msg = strbundle.getString("flock.blog.wizard.config.msg");
            $("blogWizardConfirmSettings").setAttribute("label", label);
            $("blogWizardConfirmSettings").setAttribute("description", msg);
        }
    }
    catch(e)
    {
        alert(e);
    }

    fillFinalUI();
}

function blogWizardDetectRewind()
{
    //$("blogAccountWizard").rewind();
//    window.location.reload();
//    $("blogAccountWizard").canAdvance = true;
    window.stop();
    $("blogAccountWizard").goTo("blogWizardStart");
//    $("blogAccountWizard").goTo("blogWizardStart");
//    $("blog-wizard-url").select();
}


function doRestart() {
    $("blogAccountWizard").goTo("blogWizardStart");
    return;
}

function blogWizardConfirmSettingsRewind() {
    if(!gManualMode)
        window.setTimeout("doRestart();", 0);
}

function blogWizardConfirmSettingsAdvance()
{
    dump ("blogWizardConfirmSettingsAdvance\n");
    if(true || !gB)//should this be unconditional? - yes.
    {
        var name = $("blog-api-menu").value;
        var B = flock.blog.createAPIFromName(name);
/*
        if(!B) {
            alert("Please select a blog account");
            //$("blogAccountWizard").rewind();
            return false;
        }
*/

        B.init(name, "", $("blog-uri").value, $("blog-blogid").value, "", "");

        gB = B;
    }
}

function blogTitleAdvance() {
}

function blogWizardPasswordShow() {
    if(gB.name!="atom") return;
    try {
        var authManager = Components.classes['@mozilla.org/network/http-auth-manager;1']
            .getService(Components.interfaces.nsIHttpAuthManager);
        var userDomain = {};
        var userName = {};
        var  userPassword = {};
        var uri = Components.classes["@mozilla.org/network/standard-url;1"]
            .createInstance(Components.interfaces.nsIURI);
        uri.spec=gB.apiLink;
        var port = uri.port;
        if(port==-1) {
            if(uri.scheme=="http") {
                port=80;
            }
            else if(uri.scheme=="https") {
                port=443;
            }
        }
        authManager.getAuthIdentity(uri.scheme, uri.host, port, null, null, uri.path, 
            userDomain, userName, userPassword);
        authManager.clearAll();
    } catch(e) {
    }
    //would that we could figure out how to delete only one :(
    //perhaps a patch is in order
/*
        authManager.getAuthIdentity(uri.scheme, uri.host, port, null, null, uri.path, 
            userDomain, userName, userPassword);
        authManager.setAuthIdentity(uri.scheme, uri.host, port, null, null, uri.path, 
            userDomain.value, userName.value, "cannnotbereal");
*/
}

function blogWizardPasswordAdvance() {
    dump ("blogWizardPasswordAdvance\n");
    gNewBlogAccount.username = $("blog-wizard-user").value;
    gNewBlogAccount.password = $("blog-wizard-password").value;
    $("blog-username").value = gNewBlogAccount.username;
    $("blog-password").value = gNewBlogAccount.password;

    if(gB)
    {
        gB.setAuth(gNewBlogAccount.username,gNewBlogAccount.password);
        gB.getUsersBlogs(new flock_blogWizardUsersBlogsListener());//todo: make this a preference
        $("blogAccountWizard").canAdvance = false;
    }
}

function blogWizardPasswordRewind() {
    dump("PasswordRewind...\n");
    dump(gManualMode);
    if (!gManualMode)
        window.setTimeout("doRestart();", 0);
        //$("blogAccountWizard").goTo("blogWizardStart");
}

function blogWizardTestAdvance() {
}

function blogWizardTestRewind() {
    // doRestart();
}

function blogOptionsAdvance() {
}

function blogWizardSaveAccount(aTitle, aAPIName, aAPILink, aBlogID, aEditLink)
{
    dump ("blogWizardSaveAccount \n");
    // var blogSettings = flock.blog.settings;

    var title = aTitle;
    var count = 1;
    while(flock.blog.service.accountExists(title)) {
        title = aTitle + " (" + count + ")";
        ++count;
        if(flock.blog.service.accountExists(title)) continue;

        var promptService = Components.classes["@mozilla.org/embedcomp/prompt-service;1"]
            .getService(Components.interfaces.nsIPromptService);
        var strbundle = document.getElementById("blogStringBundle");
        var out = {};
        out.value = title;
        var winTitle = strbundle.getString("flock.blog.wizard.inuse.title");
        var winText = strbundle.getString("flock.blog.wizard.inuse.text");
        var result = promptService.prompt(window, winTitle, winText, out, null, {});
        if(result) {
            title = out.value;
        }
        else {
            return false;
        }
    }

    var account = new BlogAccount(title);
    var api = new BlogAPI();

    var username = $("blog-username").value;
    var password = $("blog-password").value;
    account.title = title;
    account.blogID = aBlogID;
    account.username = username;
    account.password = password;
    api.name = aAPIName;
    api.apiLink = aAPILink;
    api.editLink = aEditLink;
    api.blogID = aBlogID;
    account.url = $("blog-wizard-url").value;
    
    try {
        flock.blog.service.saveAccount(account);
        account.setBlogAPI(api);
        dump("Making "+title+" the default account.\n");
        flock.blog.setDefaultAccount (title);
    }
    catch(e)
    {
        alert(e);
    }
    return true;
}

function blogWizardFinalShow() {
    //dump("blogWizardFinalShow");
    $("blogAccountWizard").canRewind = false;
    $("blogAccountWizard").getButton("cancel").setAttribute("hidden", true);
}

function blogWizardFinalAdvance() {
    /*
     * Here, go ahead and set the default account to be the last added account
     */
    //var blogSettings = flock_blogGetSettings();
    //var count = blogSettings.getAccountCount();
    //flock_blogSetDefaultAccountIndex(count-1);
    return true;
    //window.close();
}

function detectListener() {
}

detectListener.prototype = 
{
    onAPI: function(apis) 
    {
        // let us strongly prefer movabletype for now.
        for(var i=0;i<apis.length;++i) {
            if(apis[i].name=="movabletype") {
                gB = apis[i]; break;
            }
        }
        if(!gB) {
            for(var i=0;i<apis.length;++i) {
                if(apis[i].name=="movabletype") {
                    gB = apis[i]; break;
                }
                if(apis[i].name=="metaweblog") {
                    gB = apis[i]; break;
                }
                if(apis[i].name=="atom") {
                    gB = apis[i]; break;
                }
                if(apis[i].name=="blogger") {
                    gB = apis[i]; break;
                }
            }
        }

        fillFinalUI();
        dump("gB.name = "+gB.name+"\n");
        if(gB.name=="atom") {
            $("blogAccountWizard").canAdvance = true;
            $("blogAccountWizard").canRewind = true;
            $("blog-nonatom-container").collapsed = true;
            $("blogAccountWizard").advance();
            $("blogAccountWizard").advance();
            $("blogAccountWizard").advance();
        }
        else {
            $("blogAccountWizard").canAdvance = true;
            $("blogAccountWizard").advance();
            $("blogAccountWizard").advance();
            //$("blogAccountWizard").advance();
        }

        return;

    },

    onError: function (errorMsg) 
    {
        dump("onError in detectListener...\n");
        dump(errorMsg+"\n");

        gManualMode = true;
        switch (errorMsg) {
          case ("NO_API_FOUND"):
            $('detect-deck').setAttribute('selectedIndex', '1');
            $("blogAccountWizard").canAdvance = true;
            break;
          default:
            $('detect-deck').setAttribute('selectedIndex', '2');
        }
    }
};

function flock_blogWizardUsersBlogsListener()
{
}

function flock_blogWizardRemovePasswordsFromUrl(aUrl) {
    aUrl.match(/.+?\/\/(.+?)[$\/]/);
    alert(RegExp.$1);
    flock_blogWizardRemovePasswords(RegExp.$1);
}

function flock_blogWizardRemovePasswords(aHost) {
    var psm = Components.classes["@mozilla.org/passwordmanager;1"].getService(Components.interfaces.nsIPasswordManager);
    var enum = psm.enumerator;
    var toRemove = new Array();
    while(enum.hasMoreElements()) {
        var pw = enum.getNext();
        pw = pw.QueryInterface(Components.interfaces.nsIPassword);
        //if(pw.host==aHost && aUsername==pw.user) {
        if(pw.host==aHost) {
            toRemove[toRemove.length]==pw;
        }
    }

    for(var i=0;i<toRemove.length;++i) {
        try {
            psm.removeUser(pw.host, pw.user);
        } catch(e) { }
    }
    return null;
}

flock_blogWizardUsersBlogsListener.prototype = 
{
    redoAtom: function() {
        try {
//            flock_blogWizardRemovePasswordsFromUrl(gB.apiLink);
            doRestart();
            //$("blogAccountWizard").goTo("blogWizardStart");
            //gB.getUsersBlogs(this);
        }
        catch(e) {
            alert(e);
        }
    },
    onResult: function(aResult) 
    {
        // Return value: on success, datasource of structs containing String url, String blogid, String blogName; on failure, fault
        var rdfService = Components.classes["@mozilla.org/rdf/rdf-service;1"].
                   getService(Components.interfaces.nsIRDFService);
        var theBlogs = aResult.GetAllResources();
        if(!theBlogs.hasMoreElements()) {
            dump("Blog detection error: no blog found.\n");
            this.onError();
            return;
        }
        var theBlog;
        dump_rdf(aResult);
        while (theBlogs.hasMoreElements())
        {
            theBlog = theBlogs.getNext();
            dump("Found a blog... "+theBlog+"\n");
            var targets = aResult.ArcLabelsOut(theBlog);
            while (targets.hasMoreElements()){
              var predicate = targets.getNext();
              if (predicate instanceof Components.interfaces.nsIRDFResource){
                var target = aResult.GetTarget(theBlog, predicate, true);
                if (target instanceof Components.interfaces.nsIRDFResource){
                   //dump("Resource is: " + target.Value+"\n");
                }
                else if (target instanceof Components.interfaces.nsIRDFLiteral){
                   //dump("Literal is: "  + target.Value+"\n");
                } 
              }
            } 
            var url = aResult.GetTarget(theBlog,
                rdfService.GetResource("http://www.flock.com/rdf/url"), true).Value;
            var blogid= aResult.GetTarget(theBlog,
                rdfService.GetResource("http://www.flock.com/rdf/blogid"), true).Value;
            var blogName = aResult.GetTarget(theBlog,
                rdfService.GetResource("http://www.flock.com/rdf/blogName"), true).Value;
            var apiLink = $("blog-uri").value; //gB.apiLink;
            var editLink = gB.editLink;
            if (!editLink) editLink = apiLink;
            if (gB.name=="atom") apiLink = url;// Atom uses a url model for posting
            var apiName = $("blog-api-menu").value;
            var save = blogWizardSaveAccount(blogName, apiName, apiLink, blogid, editLink);
            if (!save){
              $("blogAccountWizard").cancel();
              return;
            }
        }

        $("blogAccountWizard").canAdvance = true;
        $("blogAccountWizard").advance();
        return;

        var title = BLOG_URN_ROOT + $("blog-title").value;
        var loader = new flock_blogPostListingListener(title, 25);
        loader.didUpdate = true;
        loader.onResult(aResult);
        $("blogAccountWizard").canAdvance = true;
        $("blogAccountWizard").advance();
    },

    onFault: function (fault)
    {
      //Error; usually happens when there is an authentication problem
      dump("onFault "+fault+" in flock_blogWizardUsersBlogsListener...\n");
      var strbundle = document.getElementById("blogStringBundle");
      if (fault == 11) { // Login error
        $("loginError").setAttribute("hidden", "false");
        $("blogAccountWizard").canAdvance = true;
        $("blogAccountWizard").rewind();
      }
      else {
        var msg = strbundle.getString("flock.blog.wizard.detecterr2");
        var prompts = Components.classes["@mozilla.org/embedcomp/prompt-service;1"]
                        .getService(Components.interfaces.nsIPromptService);
        if (prompts.confirm(window, strbundle.getString("flock.blog.wizard.retrieve.error.title"), msg)){
          if(gB.name=="atom") {
            this.redoAtom();
          }
          else {
            $("blogAccountWizard").canAdvance = true;
            $("blogAccountWizard").rewind();
          }
        }
        else {
          gManualMode = true;
          $("blogAccountWizard").canAdvance = true;
          $("blogAccountWizard").goTo('blogWizardConfirmSettings');
        }
      }
    },

    onError: function (error)
    {
        //Error; usually happens when there is a problem in the url
        dump("onError "+error+" in flock_blogWizardUsersBlogsListener...\n");
        if ((error == 404) || (error == null)) { // 404: not found, null: can't contact the site
          $("urlError").setAttribute("hidden", "false");
          $("blogAccountWizard").rewind();
          $("blogAccountWizard").canAdvance = true;
          $("blogAccountWizard").goTo('blogWizardConfirmSettings');
        }
        else {
          var strbundle = document.getElementById("blogStringBundle");
          var msg = strbundle.getString("flock.blog.wizard.detecterr2");
          var prompts = Components.classes["@mozilla.org/embedcomp/prompt-service;1"]
                          .getService(Components.interfaces.nsIPromptService);
          if (prompts.confirm(window, strbundle.getString("flock.blog.wizard.retrieve.error.title"), msg)){
            if(gB.name=="atom") {
              this.redoAtom();
            }
            else {
              $("blogAccountWizard").canAdvance = true;
              $("blogAccountWizard").rewind();
            }
          }
          else {
            gManualMode = true;
            $("blogAccountWizard").canAdvance = true;
            $("blogAccountWizard").goTo('blogWizardConfirmSettings');
          }
        }
    }
}

